; #########################################################################
; sha1 test assembler procs to go with file_hashes.pas,
; assemble by using MASM32/OMF2D.  Batch file should be in this directory.
; written by Glenn9999 on MASM32.COM, free for use and distribution 
; due credit given.
; #########################################################################
.686p
.model flat, stdcall
.mmx
.xmm
option casemap :none
; #########################################################################
Sha1Compress PROTO Buffer: DWORD, DataHash: DWORD
; #########################################################################
.data?
ESPSave    dd ?
EBPSave    dd ?
WProcData  dd 80 dup(?)

.code
; #########################################################################
Sha1Loop1    macro a, b, cf, d, e, w

MOV  EBP, d
XOR  EBP, cf
AND  EBP, b
XOR  EBP, d
ADD  e, EBP
;----------------------------------------
MOV  EBP, a
ROL  EBP, 5
ADD  e, EBP
;----------------------------------------
ADD  e, w
add  e, 05A827999h
;----------------------------------------
ROL  b, 30
;----------------------------------------
endm

; #########################################################################
Sha1Loop2    macro a, b, cf, d, e, w

MOV  EBP, d
XOR  EBP, cf
XOR  EBP, b
ADD  e, EBP
;----------------------------------------
MOV  EBP, a
ROL  EBP, 5
ADD  e, EBP
;----------------------------------------
ADD  e, w
ADD  e, 06ED9EBA1h
;----------------------------------------
ROL  b, 30
;----------------------------------------
endm

; #########################################################################
Sha1Loop3    macro a, b, cf, d, e, w

MOV  EBP, b
AND  EBP, cf
MOV  ESP, b
OR   ESP, cf
AND  ESP, d
OR   EBP, ESP
ADD  e, EBP
;----------------------------------------
MOV  EBP, a
ROL  EBP, 5
ADD  e, EBP
;----------------------------------------
ADD  e, w
ADD  e, 08F1BBCDCh
;----------------------------------------
ROL  b, 30
;----------------------------------------
endm

; #########################################################################
Sha1Loop4    macro a, b, cf, d, e, w

MOV  EBP, d
XOR  EBP, cf
XOR  EBP, b
ADD  e, EBP
;----------------------------------------
MOV  EBP, a
ROL  EBP, 5
ADD  e, EBP
;----------------------------------------
ADD  e, w
ADD  e, 0CA62C1D6h
;----------------------------------------
ROL  b, 30
;----------------------------------------
endm

; #########################################################################
Sha1LoadW  macro buffer, w
; moves data from buffer to w to process in first section.
;----------------------------------------
MOV      EDX, 0                   
@loop1:
MOV      ECX, [buffer+EDX*4]         
BSWAP    ECX                      
MOV      [w+EDX*4], ECX         
INC      EDX                      
CMP      EDX, 15                  
JLE      @loop1                   
;----------------------------------------
@loop2:                           
MOV      ECX, [w+EDX*4-12]      
XOR      ECX, [w+EDX*4-32]      
XOR      ECX, [w+EDX*4-56]      
XOR      ECX, [w+EDX*4-64]      
ROL      ECX, 1                   
MOV      [w+EDX*4], ECX         
INC      EDX                      
CMP      EDX, 79                  
JLE      @loop2                   
;----------------------------------------
endm

; #########################################################################
Sha1Compress proc Buffer: DWORD, DataHash: DWORD

 pushad
 MOV  ESPSave, ESP
 MOV  EBPSave, EBP
;----------------------------------------
 lea  edi, WProcData
 mov  esi, Buffer

 Sha1LoadW esi, edi
 mov  ebp, DataHash
 mov  eax, [ebp+0]
 mov  ebx, [ebp+4]
 mov  ecx, [ebp+8]
 mov  edx, [ebp+12]
 mov  esi, [ebp+16]
;----------------------------------------
 Sha1Loop1 eax, ebx, ecx, edx, esi, dword ptr [edi+ 0*4]
 Sha1Loop1 esi, eax, ebx, ecx, edx, dword ptr [edi+ 1*4]
 Sha1Loop1 edx, esi, eax, ebx, ecx, dword ptr [edi+ 2*4]
 Sha1Loop1 ecx, edx, esi, eax, ebx, dword ptr [edi+ 3*4]
 Sha1Loop1 ebx, ecx, edx, esi, eax, dword ptr [edi+ 4*4]
 Sha1Loop1 eax, ebx, ecx, edx, esi, dword ptr [edi+ 5*4]
 Sha1Loop1 esi, eax, ebx, ecx, edx, dword ptr [edi+ 6*4]
 Sha1Loop1 edx, esi, eax, ebx, ecx, dword ptr [edi+ 7*4]
 Sha1Loop1 ecx, edx, esi, eax, ebx, dword ptr [edi+ 8*4]
 Sha1Loop1 ebx, ecx, edx, esi, eax, dword ptr [edi+ 9*4]
 Sha1Loop1 eax, ebx, ecx, edx, esi, dword ptr [edi+10*4]
 Sha1Loop1 esi, eax, ebx, ecx, edx, dword ptr [edi+11*4]
 Sha1Loop1 edx, esi, eax, ebx, ecx, dword ptr [edi+12*4]
 Sha1Loop1 ecx, edx, esi, eax, ebx, dword ptr [edi+13*4]
 Sha1Loop1 ebx, ecx, edx, esi, eax, dword ptr [edi+14*4]
 Sha1Loop1 eax, ebx, ecx, edx, esi, dword ptr [edi+15*4]
 Sha1Loop1 esi, eax, ebx, ecx, edx, dword ptr [edi+16*4]
 Sha1Loop1 edx, esi, eax, ebx, ecx, dword ptr [edi+17*4]
 Sha1Loop1 ecx, edx, esi, eax, ebx, dword ptr [edi+18*4]
 Sha1Loop1 ebx, ecx, edx, esi, eax, dword ptr [edi+19*4]
;----------------------------------------
 Sha1Loop2 eax, ebx, ecx, edx, esi, dword ptr [edi+20*4]
 Sha1Loop2 esi, eax, ebx, ecx, edx, dword ptr [edi+21*4]
 Sha1Loop2 edx, esi, eax, ebx, ecx, dword ptr [edi+22*4]
 Sha1Loop2 ecx, edx, esi, eax, ebx, dword ptr [edi+23*4]
 Sha1Loop2 ebx, ecx, edx, esi, eax, dword ptr [edi+24*4]
 Sha1Loop2 eax, ebx, ecx, edx, esi, dword ptr [edi+25*4]
 Sha1Loop2 esi, eax, ebx, ecx, edx, dword ptr [edi+26*4]
 Sha1Loop2 edx, esi, eax, ebx, ecx, dword ptr [edi+27*4]
 Sha1Loop2 ecx, edx, esi, eax, ebx, dword ptr [edi+28*4]
 Sha1Loop2 ebx, ecx, edx, esi, eax, dword ptr [edi+29*4]
 Sha1Loop2 eax, ebx, ecx, edx, esi, dword ptr [edi+30*4]
 Sha1Loop2 esi, eax, ebx, ecx, edx, dword ptr [edi+31*4]
 Sha1Loop2 edx, esi, eax, ebx, ecx, dword ptr [edi+32*4]
 Sha1Loop2 ecx, edx, esi, eax, ebx, dword ptr [edi+33*4]
 Sha1Loop2 ebx, ecx, edx, esi, eax, dword ptr [edi+34*4]
 Sha1Loop2 eax, ebx, ecx, edx, esi, dword ptr [edi+35*4]
 Sha1Loop2 esi, eax, ebx, ecx, edx, dword ptr [edi+36*4]
 Sha1Loop2 edx, esi, eax, ebx, ecx, dword ptr [edi+37*4]
 Sha1Loop2 ecx, edx, esi, eax, ebx, dword ptr [edi+38*4]
 Sha1Loop2 ebx, ecx, edx, esi, eax, dword ptr [edi+39*4]
;-------------------------------------------------------
 Sha1Loop3 eax, ebx, ecx, edx, esi, dword ptr [edi+40*4]
 Sha1Loop3 esi, eax, ebx, ecx, edx, dword ptr [edi+41*4]
 Sha1Loop3 edx, esi, eax, ebx, ecx, dword ptr [edi+42*4]
 Sha1Loop3 ecx, edx, esi, eax, ebx, dword ptr [edi+43*4]
 Sha1Loop3 ebx, ecx, edx, esi, eax, dword ptr [edi+44*4]
 Sha1Loop3 eax, ebx, ecx, edx, esi, dword ptr [edi+45*4]
 Sha1Loop3 esi, eax, ebx, ecx, edx, dword ptr [edi+46*4]
 Sha1Loop3 edx, esi, eax, ebx, ecx, dword ptr [edi+47*4]
 Sha1Loop3 ecx, edx, esi, eax, ebx, dword ptr [edi+48*4]
 Sha1Loop3 ebx, ecx, edx, esi, eax, dword ptr [edi+49*4]
 Sha1Loop3 eax, ebx, ecx, edx, esi, dword ptr [edi+50*4]
 Sha1Loop3 esi, eax, ebx, ecx, edx, dword ptr [edi+51*4]
 Sha1Loop3 edx, esi, eax, ebx, ecx, dword ptr [edi+52*4]
 Sha1Loop3 ecx, edx, esi, eax, ebx, dword ptr [edi+53*4]
 Sha1Loop3 ebx, ecx, edx, esi, eax, dword ptr [edi+54*4]
 Sha1Loop3 eax, ebx, ecx, edx, esi, dword ptr [edi+55*4]
 Sha1Loop3 esi, eax, ebx, ecx, edx, dword ptr [edi+56*4]
 Sha1Loop3 edx, esi, eax, ebx, ecx, dword ptr [edi+57*4]
 Sha1Loop3 ecx, edx, esi, eax, ebx, dword ptr [edi+58*4]
 Sha1Loop3 ebx, ecx, edx, esi, eax, dword ptr [edi+59*4]
;-------------------------------------------------------
 Sha1Loop4 eax, ebx, ecx, edx, esi, dword ptr [edi+60*4]
 Sha1Loop4 esi, eax, ebx, ecx, edx, dword ptr [edi+61*4]
 Sha1Loop4 edx, esi, eax, ebx, ecx, dword ptr [edi+62*4]
 Sha1Loop4 ecx, edx, esi, eax, ebx, dword ptr [edi+63*4]
 Sha1Loop4 ebx, ecx, edx, esi, eax, dword ptr [edi+64*4]
 Sha1Loop4 eax, ebx, ecx, edx, esi, dword ptr [edi+65*4]
 Sha1Loop4 esi, eax, ebx, ecx, edx, dword ptr [edi+66*4]
 Sha1Loop4 edx, esi, eax, ebx, ecx, dword ptr [edi+67*4]
 Sha1Loop4 ecx, edx, esi, eax, ebx, dword ptr [edi+68*4]
 Sha1Loop4 ebx, ecx, edx, esi, eax, dword ptr [edi+69*4]
 Sha1Loop4 eax, ebx, ecx, edx, esi, dword ptr [edi+70*4]
 Sha1Loop4 esi, eax, ebx, ecx, edx, dword ptr [edi+71*4]
 Sha1Loop4 edx, esi, eax, ebx, ecx, dword ptr [edi+72*4]
 Sha1Loop4 ecx, edx, esi, eax, ebx, dword ptr [edi+73*4]
 Sha1Loop4 ebx, ecx, edx, esi, eax, dword ptr [edi+74*4]
 Sha1Loop4 eax, ebx, ecx, edx, esi, dword ptr [edi+75*4]
 Sha1Loop4 esi, eax, ebx, ecx, edx, dword ptr [edi+76*4]
 Sha1Loop4 edx, esi, eax, ebx, ecx, dword ptr [edi+77*4]
 Sha1Loop4 ecx, edx, esi, eax, ebx, dword ptr [edi+78*4]
 Sha1Loop4 ebx, ecx, edx, esi, eax, dword ptr [edi+79*4]
;-------------------------------------------------------
 MOV  ESP, ESPSave
 MOV  EBP, EBPSave

 mov   edi, DataHash
 add   dword ptr [edi+0], eax
 add   dword ptr [edi+4], ebx
 add   dword ptr [edi+8], ecx
 add   dword ptr [edi+12], edx
 add   dword ptr [edi+16], esi   

;-------------------------------------------------------
 popad
 ret

Sha1Compress  endp
; #########################################################################
end